
require 'levels/level1'
require 'levels/level2'
require 'commands'

function love.load()
	--texture data
	player = love.graphics.newImage("textures/player.png")
	door = love.graphics.newImage("textures/door.png")
	vase = love.graphics.newImage("textures/vase.png")
	key = love.graphics.newImage("textures/key.png")
	flashlight = love.graphics.newImage("textures/light.png")
	mouse = love.graphics.newImage("textures/mouse.png")
	inventory = love.graphics.newImage("textures/inventory.jpg")
	spike = love.graphics.newImage("textures/spike.png")

	--map position
	tilex = 0
	tiley = 0
	
	playerx = 400
	playery = 300
	health = 30
	
	-- make default mouse invisible
	love.mouse.setVisible(false)	
	
	--inventory
	inventoryx = 40000000000000000
	inventoryy = 30000000000000000
		
	--default key status
	key_state = "exists"
	
	--default flash light status
	flash_state = "exists"
	
	fade = 100
	
	level1()
		
end

function love.draw()
	
	--draw tile
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(tile, tilex, tiley)

	--draw the player
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(player, playerx, playery)
	
	--draw the door
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(door, doorx, doory)
	
	--draw the inventory
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(inventory, inventoryx, inventoryy)
	
	--draw the key
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(key, keyx, keyy)
	
	--draw the flash light
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(flashlight, flashx, flashy)
	
	--draw the spike
	for i=1,spiketotal do	
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(spike, spikex+i*102, spikey)
	end
	
	--fade/darken
	love.graphics.setColor(0, 0, 0, fade)
	love.graphics.rectangle("fill", 0, 0, 800, 600)
	
	--draw health squares
	love.graphics.setColor(255, 0, 0, 255)
	love.graphics.rectangle("fill", 10, 20, health*5, 30)
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.print("health", 10, 20)
	
	--draw the custom mouse image
	mousex, mousey = love.mouse.getPosition() 
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(mouse, mousex, mousey) 
	
end

function love.update(dt)
		
	--controls
	if moveright == true then
		if love.keyboard.isDown("right") or love.keyboard.isDown("d") then
			tilex = tilex - 300*dt
			keyx = keyx - 300*dt
			doorx = doorx - 300*dt
			flashx = flashx - 300*dt
			spikex = spikex - 300*dt
		end 
	end
	
	if moveleft == true then
		if love.keyboard.isDown("left") or love.keyboard.isDown("a") then
			tilex = tilex + 300*dt
			keyx = keyx + 300*dt
			doorx = doorx + 300*dt
			flashx = flashx + 300*dt
			spikex = spikex + 300*dt
		end 
	end
	
	if movedown == true then
		if love.keyboard.isDown("down") or love.keyboard.isDown("s") then
			tiley = tiley - 300*dt
			keyy = keyy - 300*dt
			doory = doory - 300*dt
			flashy = flashy - 300*dt
			spikey = spikey - 300*dt
		end 
	end
	
	if moveup == true then
		if love.keyboard.isDown("up") or love.keyboard.isDown("w") then
			tiley = tiley + 300*dt
			keyy = keyy + 300*dt
			doory = doory + 300*dt
			flashy = flashy + 300*dt
			spikey = spikey + 300*dt
		end 
	end
	
	--edge of map	
	--left
	if tilex >= playerx then
		moveleft = false
	else
		moveleft = true
	end
	
	--right
	if tilex <= playerx-mapwidth then
		moveright = false
	else
		moveright = true
	end
	
	--up
	if tiley >= playery then
		moveup = false
	else
		moveup = true
	end
	
	--down
	if tiley <= playery-mapheight then
		movedown = false
	else
		movedown = true
	end	

	--kill the player
	if health <= 0 then
		kill()
	else
	end
		
	--move the spike
	spikey = spikey + 200*dt
	if spikey >= mapheight then
		spikey = 0
	end
		
	--use key
	if key_state == "stored" then
		keyx = inventoryx + 110
		keyy = inventoryy + 30	
		
		--check if the player is near the door
		if playerx >= doorx - 80 then
			if playerx <= doorx + 80 then
				if playery >= doory - 80 then
					if playery <= doory + 80 then
						key_state = "exists"
						print("key used")
						if level == 1 then
							dooreffect1()
						elseif level == 2 then
							dooreffect2()
						elseif level == 3 then
							dooreffect3()
						else
							dooreffect1()
						end
					end
				end
			end
		end
	end
	
	--key text
	if flash_state == "stored" then
		fade = 60
		flashx = inventoryx + 30
		flashy = inventoryy +10
	end
	
	--spike hit box
	insidebox(playerx, playery, spikex, spikey, 45, 51)
	if insidebox then
		print("hit")
	end
end

function love.keypressed(k)
	--inventory
	if k == "escape" then
		inventoryx = 300
		inventoryy = 200	  
	else
		fade = defaultfade
		inventoryx = 40000000000000000
		inventoryy = 30000000000000000
	end
	
	--quit
	if k == "q" then
		love.event.quit()
	end
	
end

function love.mousepressed(x, y, button)
   if button == "l" then	
	--pick-up key
		if playerx >= keyx - 62 then
			if playerx <= keyx + 62 then
				if playery >= keyy - 31 then
					if playery <= keyy + 31 then
						key_state = "stored"
					end
				end 
			end
		end
		
		--collect flash light
		if x >= flashx - 45 then
			if x <= flashx + 45 then
				if y >= flashy - 51 then
					if y <= flashy + 51 then
						flash_state = "stored"
					end
				end 
			end
		end
	end
end




